using System;
using System.Collections.Generic;
using System.Text;

namespace Unit4.CollectionsLib
{
    /// <summary>
    /// <h3 dir="rtl" style="color:red; font-family: Helvetica, Arial, sans-serif">
    ///        T    .
    /// </h3>
    /// </summary>
    /// <author>   ,   ,  ,  </author>
    /// <version> 18.11.2007 </version>
    /// <typeparam name="T">     </typeparam>
    public class BinTreeNode<T>
    {
        private BinTreeNode<T> left;
        private T info;
        private BinTreeNode<T> right;

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///    ;    x      null
        /// </b>
        /// </summary>
        /// <param name="x">   </param>
        public BinTreeNode(T x)
        {
            this.left = null;
            this.info = x;
            this.right = null;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///       x;
        ///  left -right  ( )    ;
        ///     null
        /// </b>
        /// </summary>
        /// <param name="left"> -  </param>
        /// <param name="x">   </param>
        /// <param name="right"> -  </param>
        public BinTreeNode(BinTreeNode<T> left, T x, BinTreeNode<T> right)
        {
            this.left = left;
            this.info = x;
            this.right = right;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///      
        /// </b>
        /// </summary>
        /// <returns>   </returns>
        public T GetInfo()
        {
            return this.info;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///       -x
        /// </b>
        /// </summary>
        /// <param name="x">    </param>
        public void SetInfo(T x)
        {
            this.info = x;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///       ;
        ///       null
        /// </b>
        /// </summary>
        /// <returns>   </returns>
        public BinTreeNode<T> GetLeft()
        {
            return this.left;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///       ;
        ///       null
        /// </b>
        /// </summary>
        /// <returns>   </returns>
        public BinTreeNode<T> GetRight()
        {
            return this.right;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///       left
        /// </b>
        /// </summary>
        /// <param name="left">    </param>
        public void SetLeft(BinTreeNode<T> left)
        {
            this.left = left;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///       right
        /// </b>
        /// </summary>
        /// <param name="right">    </param>
        public void SetRight(BinTreeNode<T> right)
        {
            this.right = right;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///        
        /// </b>
        /// </summary>
        /// <returns>       </returns>
        public override string ToString()
        {
            return this.info.ToString();
        }
    }
}
