using System;
//using System.Collections.Generic;
using System.Text;
using Unit4.CollectionsLib;

namespace Unit4.UtilsLib
{
    /// <summary> 
    /// <h3 dir="rtl" style="color:red; font-family: Helvetica, Arial, sans-serif">
    ///           
    /// </h3> 
    /// </summary>
    /// <author>   ,   ,  ,  </author>
    /// <version> 27.11.2007 </version>
    public class ListUtils
    {
        private ListUtils() { }
        private static Random random = new Random();

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///      
        /// </b>
        /// </summary>
        /// <param name="lst">     </param>
        /// <returns>    </returns>
        public static int GetLength(List<int> lst)
        {
            int len = 0;
            Node<int> pos = lst.GetFirst();

            while (pos != null)
            {
                len++;
                pos = pos.GetNext();
            }
            return (len);
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///          
        /// </b>
        /// </summary>
        /// <param name="lst">     </param>
        /// <param name="x">    </param>
        /// <returns> null     .     </returns>
        public static Node<int> GetPosition(List<int> lst, int x)
        {
            Node<int> pos = lst.GetFirst();

            while (pos != null)
            {
                if (pos.GetInfo() == x)
                    return (pos);
                else
                    pos = pos.GetNext();
            }
            return (null);
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///         
        /// </b>
        /// </summary>
        /// <param name="lst">     </param>
        /// <param name="x">   </param>
        public static void RemoveAllOccurances(List<int> lst, int x)
        {
            Node<int> pos = lst.GetFirst();

            while (pos != null)
            {
                if (pos.GetInfo().CompareTo(x) == 0)
                    pos = lst.Remove(pos);
                else
                    pos = pos.GetNext();
            }
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///      
        /// </b>
        /// </summary>
        /// <param name="lst">        </param>
        public static void Reverse(List<int> lst)
        {
            Node<int> pos = lst.GetFirst();

            while (pos != null)
            {
                lst.Insert(null, pos.GetInfo());
                pos = lst.Remove(pos);
            }
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///          
        /// </b>
        /// </summary>
        /// <param name="lst1">     </param>
        /// <param name="lst2">     </param>
        /// <returns>          </returns>
        public static List<int> Common(List<int> lst1, List<int> lst2)
        {
            int x;
            List<int> lst3 = new List<int>();
            Node<int> pos1 = lst1.GetFirst();
            Node<int> pos3 = null;

            while (pos1 != null)
            {
                x = pos1.GetInfo();
                if (ListUtils.GetPosition(lst2, x) != null)
                    if (ListUtils.GetPosition(lst3, x) == null)
                        pos3 = lst3.Insert(pos3, x);
                pos1 = pos1.GetNext();
            }
            return (lst3);
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///          
        /// </b>
        /// </summary>
        /// <param name="numOfItems">     </param>
        /// <param name="low">     </param>
        /// <param name="high">     </param>
        /// <returns>     </returns>
        public static List<int> CreateRandomList(int numOfItems, int low, int high)
        {
            int x;
            List<int> lst = new List<int>();       

            for (int i = 1; i <= numOfItems; i++)
            {
                x = ListUtils.random.Next(low, high + 1);
                lst.Insert(null, x);
            }
            return (lst);
        }



        //*****************************************************************//
        //                                                           //
        //*****************************************************************//
        
        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///   (  )    ;
        ///      , ,    ;
        ///    InsertIntoSortedList
        /// </b>
        /// </summary>
        /// <param name="lst">    </param>
        /// <returns>       </returns>
        public static List<int> InsertionSort(List<int> lst)
        {
            List<int> tmpList = new List<int>();
            Node<int> pos = lst.GetFirst();

            while (pos != null)
            {
                ListUtils.InsertIntoSortedList(tmpList, pos.GetInfo());
                pos = pos.GetNext();
            }
            return (tmpList);
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///      
        /// </b>
        /// </summary>
        /// <param name="lst">     </param>
        /// <param name="x">  ( )  </param>
        public static void InsertIntoSortedList(List<int> lst, int x)
        {
            bool inList = false;
            Node<int> prev = null;
            Node<int> pos = lst.GetFirst();

            while (pos != null && !inList)
            {
                if (x < pos.GetInfo())
                    inList = true;
                else
                {
                    prev = pos;
                    pos = pos.GetNext();
                }
            }
            lst.Insert(prev, x);
        }

        //*****************************************************************//
        //                                                            //
        //*****************************************************************//
     
        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///    
        /// </b>
        /// </summary>
        /// <param name="lst1">    </param>
        /// <param name="lst2">    </param>
        /// <returns>          </returns>
        public static List<int> MergeLists(List<int> lst1, List<int> lst2)
        {
            Node<int> pos1, pos2, pos3 = null;
            List<int> lst3 = new List<int>();

            pos1 = lst1.GetFirst();
            pos2 = lst2.GetFirst();
            while (pos1 != null && pos2 != null)
            {
                if (pos1.GetInfo() > pos2.GetInfo())
                {
                    pos3 = lst3.Insert(pos3, pos2.GetInfo());
                    pos2 = pos2.GetNext();
                }
                else
                {
                    pos3 = lst3.Insert(pos3, pos1.GetInfo());
                    pos1 = pos1.GetNext();
                }
            }

            while (pos1 != null)
            {
                pos3 = lst3.Insert(pos3, pos1.GetInfo());
                pos1 = pos1.GetNext();
            }

            while (pos2 != null)
            {
                pos3 = lst3.Insert(pos3, pos2.GetInfo());
                pos2 = pos2.GetNext();
            }
            return (lst3);
        }
    }
}
